<template>
  <div class="app-container">
    <el-card>
      <!--      <span style="margin-left: 15px">班次类型:</span>-->
      <span style="margin-left: 10px">工位号：</span>
      <el-select v-model="dataTypeValue" clearable placeholder="请选择工位号" size="small" style="width: 150px">
        <el-option
          v-for="item in dataType"
          :key="item.value"
          :label="item.label"
          :value="item.value"
          size="mini"/>
      </el-select>
      <el-button
        icon="el-icon-search"
        plain
        size="small"
        style="margin-left: 15px"
        type="primary"
        @click="pageSize=20;pageCurrent=1;searchTable()">查询
      </el-button>
      <el-button icon="el-icon-circle-plus-outline" size="small" type="distribution" @click="addShiftTable('form')">
        新增
      </el-button>
      <!--<el-button type="info" plain size="small" icon="el-icon-upload2" @click="importOrder('form')">导入</el-button>-->
      <el-table
        :data="tableData"
        border
        center
        height="450"
        size="mini"
        style="width: 70%">
        <el-table-column align="center" label="序号" type="index"/>
        <el-table-column align="center" label="工位号">
          <template slot-scope="scope">
            {{ scope.row.工位号 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="数据类型">
          <template slot-scope="scope">
            {{ scope.row.数据类型 }}
          </template>
        </el-table-column>
        <el-table-column align="left" disabled label="数据名称" width="300">
          <template slot-scope="scope">
            {{ scope.row.数据名称 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="操作时间">
          <template slot-scope="scope">
            {{ scope.row.操作时间 }}
          </template>
        </el-table-column>
        <el-table-column align="center" label="操作" width="200">
          <template slot-scope="scope">
            <el-button
              icon="el-icon-edit"
              plain
              size="mini"
              type="text"
              @click="editShiftTable(scope.row)">编辑
            </el-button>
            <el-button
              icon="el-icon-delete"
              plain
              size="mini"
              type="text"
              @click="handleDelete(scope.row)">删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block" style="margin-top: 10px;">
        <el-pagination
          :current-page="pageCurrent"
          :page-size="20"
          :page-sizes="[10, 20, 30, 40, 50]"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>
    </el-card>
    <el-dialog :title="title" :visible.sync="dialogFormVisible" center style="min-height: 200px;" width="400px">
      <el-form ref="form" :model="form" label-position="right" label-width="110px">
        <el-form-item label="工位号" prop="name" style="display: inline-block">
          <el-select
            v-model="form.opName"
            clearable
            placeholder="请选择工位号"
            size="small"
            style="width: 185px">
            <el-option
              v-for="item in dataType"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              size="mini"/>
          </el-select>
        </el-form-item>
        <el-form-item label="数据类型" prop="value" style="display: inline-block">
          <el-input v-model="form.dataType" placeholder="数据类型" size="small"/>
        </el-form-item>
        <el-form-item label="数据名称" prop="descript" style="display: inline-block">
          <el-input
            v-model="form.dataName"
            placeholder="数据名称"
            size="small"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="small" @click="callOff('form')">取消</el-button>
        <el-button v-if="title === '编辑'" size="small" type="primary" @click="submitAdd1('form')">确定</el-button>
        <el-button v-if="title === '增加'" size="small" type="primary" @click="submitAdd('form')">确定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogFormVisible3" center style="min-height: 200px" title="导入" width="900px">
      <div class="app-container">
        <upload-excel-component style="margin-left: 15%" @on-selected-file="selected"/>
        <div style="margin-left: 395px">
          <span v-show="worksheet.length > 1" style="cursor: pointer;width: 50px;" @click="removeAll"><i
            class="el-icon-close"/></span>
          <el-upload :file-list="itemFile" :on-remove="handleRemove" action="" style="width: 220px"/>
        </div>
        <div v-if="worksheet.length !== 0" style="margin: 3px 0 0 395px">
          <el-button icon="el-icon-upload2" size="small" type="primary" @click="basicPartsToSQL">导入到数据库
          </el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { sleep } from '../../../utils/tool'

export default {
  data() {
    return {
      worksheet: [],
      itemFile: [],
      unSpecification: [],
      dataTypeValue: '',
      dataType: [],
      tableData: [],
      hour: '',
      minutes: '',
      seconds: '',
      dialogFormVisible: false,
      dialogFormVisible3: false,
      form: {
        id: '',
        opName: '', // 工位号
        dataType: '', // 检验项目
        dataName: '' // 检验标准
      },
      rules: { // 表单验证规则
        dataTypeValue: [{ required: true, message: '请选择', trigger: 'change' }],
        name: [{ required: true, message: '请输入', trigger: 'blur' }]
      },
      title: '编辑',
      pageCurrent: 1,
      pageSize: 20,
      total: 0
    }
  },
  created() {
    this.searchTable()
    this.getStationNumber()
  },
  methods: {
    getStationNumber() {
      this.stationNumber = []
      var param = []
      var Data = this.CreateData('11', 'MES_计划BOM_工位与名称_查询', param)
      this.ExecDatabase(Data).then(response => {
        // if (response.data.length) {
        //   this.stationNumberValue = response.data[0].工位号
        //   this.stationName = response.data[0].工序名称
        // }
        for (let i = 0; i < response.data.length; i++) {
          this.dataType.push({
            label: response.data[i].工位号,
            value: response.data[i].工位号,
            labelName: response.data[i].工位名称
          })
        }
      })
    },
    searchTable() {
      this.tableData = []
      let dataTypeValue_check
      this.dataTypeValue ? dataTypeValue_check = 1 : dataTypeValue_check = 0
      var param = []
      param[0] = ['工位号_ischeck', dataTypeValue_check]
      param[1] = ['工位号', this.dataTypeValue]
      param[2] = ['PageCurrent', this.pageCurrent]
      param[3] = ['PageSize', this.pageSize]
      param[4] = ['PageCount', '1111', 'int', '1']
      param[5] = ['ItemCount', '1111', 'int', '1']
      var Data = this.CreateData('11', 'MES_工位手动录入_基本表_查询', param)
      this.ExecDatabase(Data).then(response => {
        console.log(response, 66)
        if (response.data.result.length !== 0) {
          this.tableData = response.data.result
        }
        this.total = parseInt(response.data.output[0].ItemCount)
        this.loading = false
        console.log(this.tableData, 'this.tableData')
      })
    },
    addShiftTable(formName) {
      if (this.$refs[formName] !== undefined) {
        this.$refs[formName].resetFields()
      }
      this.title = '增加'
      this.form.id = ''
      this.form.opName = '' // 工位号
      this.form.dataType = '' // 检验项目
      this.form.dataName = '' // 检验标准
      this.dialogFormVisible = true
    },
    submitAdd(formName) {
      if (!this.form.opName || !this.form.dataType || !this.form.dataName) {
        this.$message.warning('请填写完全后提交')
        return
      }
      this.$refs[formName].validate((valid) => {
        if (valid) {
          var param = []
          param[0] = ['工位号', this.form.opName]
          param[1] = ['数据类型', this.form.dataType]
          param[2] = ['数据名称', this.form.dataName]
          var Data = this.CreateData('12', 'MES_工位手动录入_基本表_增加', param)
          this.ExecDatabase(Data).then(response => {
            console.log(response)
            if (response.data[0].result === '1') {
              this.$message({
                message: '增加成功',
                type: 'success'
              })
              this.dialogFormVisible = false
              this.searchTable()
            } else {
              this.$message.error('增加失败！')
            }
          })
          this.dialogFormVisible = false
        } else {
          return false
        }
      })
    },
    editShiftTable(row) {
      if (this.$refs['form'] !== undefined) {
        this.$refs['form'].resetFields()
      }
      this.form.id = row.Id
      this.form.opName = row.工位号 // 工位号
      this.form.dataType = row.数据类型 // 检验项目
      this.form.dataName = row.数据名称 // 检验标准
      this.title = '编辑'
      this.dialogFormVisible = true
    },
    submitAdd1() {
      var param = []
      param[0] = ['工位号', this.form.opName]
      param[1] = ['数据类型', this.form.dataType]
      param[2] = ['数据名称', this.form.dataName]
      param[3] = ['Id', this.form.id]
      var Data = this.CreateData('12', 'MES_工位手动录入_基本表_修改', param)
      this.ExecDatabase(Data).then(response => {
        if (response.data[0].result === '1') {
          this.$message({
            message: '修改成功',
            type: 'success'
          })
          this.searchTable()
        } else {
          this.$message.error('修改失败！')
        }
      })
      this.dialogFormVisible = false
    },
    handleDelete(row) {
      this.$confirm('此操作将永久删除该行, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        var param = []
        param[0] = ['id', row.Id]
        var Data = this.CreateData('12', 'MES_工位手动录入_基本表_删除', param)
        this.ExecDatabase(Data).then(response => {
          if (response.data[0].result === '1') {
            this.$message({
              message: '删除成功',
              type: 'success'
            })
            this.searchTable()
          } else {
            this.$message.error('删除失败！')
          }
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消删除'
        })
      })
    },
    callOff() {
      this.dialogFormVisible = false
    },
    importOrder() {
      this.dialogFormVisible3 = true
    },
    removeAll() {
      this.worksheet = []
      this.itemFile = []
    },
    async selected(data) { // 选择需要导入的文件
      console.log(data, 1111)
      this.worksheet = data.worksheet // 获取每个多选文件的表格坐标及值
      this.itemFile = data.itemFile
    },
    handleRemove(file) { // 移除文件
      for (let i = 0; i < this.itemFile.length; i++) {
        if (this.itemFile[i].name === file.name) {
          this.worksheet.splice(i, 1)
          this.itemFile.splice(i, 1)
        }
      }
    },
    async basicPartsToSQL() {
      try {
        this.loading = true
        this.err = 0
        for (let j = this.worksheet.length - 1; j >= 0; j--) {
          let name,
            value,
            type,
            descript,
            comments
          for (let i = 0; i < 999; i++) {
            const attr = i + 2
            name = this.worksheet[j][`A${attr}`] ? this.worksheet[j][`A${attr}`].v : ''
            value = this.worksheet[j][`B${attr}`] ? this.worksheet[j][`B${attr}`].v : ''
            type = this.worksheet[j][`C${attr}`] ? this.worksheet[j][`C${attr}`].v : ''
            descript = this.worksheet[j][`D${attr}`] ? this.worksheet[j][`D${attr}`].v : ''
            comments = this.worksheet[j][`E${attr}`] ? this.worksheet[j][`E${attr}`].v : ''
            console.log(name, value, type, descript, comments)
            if (!name) {
              break
            } else {
              if (name) {
                await sleep(50)
                await this.insertToSQL(name, value, type, descript, comments)
              } else {
                this.loading = false
                this.disabled = false
                return
              }
            }
          }
          this.itemFile.splice(j, 1)
          this.worksheet.splice(j, 1)
          this.err === 0 ? this.$message.success(`导入完成`) : this.$message.error(`导入失败个数为${this.err}，请检查文件是否正确`)
        }
        this.loading = false
        this.searchTable()
      } catch (e) {
        this.err++
        this.loading = false
        this.$notify.error(`导入数据错误,请检查导入文件是否正确`)
        console.log(`导入数据错误${e}`)
      }
    },
    async insertToSQL(name, value, type, descript, comments) {
      try {
        var param = []
        param[0] = ['name', name]
        param[1] = ['value', value]
        param[2] = ['type', type]
        param[3] = ['descript', descript]
        param[4] = ['comments', comments]
        var Data = this.CreateData('12', 'Recipe_WorkBook_Excel', param)
        const response = await this.ExecDatabase(Data)
        if (response.data[0].result === '1') {
          this.$notify.success(`${name}导入成功`)
        } else {
          this.$notify.error(`${name}导入失败`)
        }
      } catch (e) {
        this.err++
        this.$message.error(`导入数据错误`)
        console.log(`导入数据错误${e}`)
      }
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.pageCurrent = 1
      this.searchTable()
    },
    handleCurrentChange(val) {
      this.pageCurrent = val
      this.searchTable()
    }
  }
}
</script>

<style scoped>
</style>

